/*================================================================
 File name: TegoSND.h

 TegoSND.DLL containd sp_ functions for playing WAV files
 through the PC speaker.

 (C) Copyright TegoSoft Inc. 1989-1994, (R) All rights reserved.
 TegoSoft Inc.
 Box 389
 Bellmore, NY 11710
 Phone:(516)783-4824
 ===============================================================*/


extern "C" 
{
/*------- Open a session ---------*/
/* Old version */
int  FAR PASCAL _export  sp_OpenWaveSession     ( HWND  hWnd,
						  LPSTR lpstrFileName );
/* New version */
int  FAR PASCAL _export  sp_OpenSession ( LPSTR lpstrFileName );


int  FAR PASCAL _export sp_OpenCustomSession   ( HWND  hWnd,
						 LPSTR lpstrFileName, 
						 long  lSamplingRate  );

long FAR PASCAL _export sp_GetSoundSizeInBytes ( int iSessionHandler );

long FAR PASCAL _export sp_GetSamplingRate     ( int iSessionHandler );

long FAR PASCAL _export sp_PlaySnd             ( int iSessionHandler,
						 long lStartPoint,
						 long lEndPoint );

int FAR PASCAL _export  sp_CloseSession        ( int iSessionHandler );

int FAR PASCAL _export  sp_SetSpeed            ( int iSessionHandler,
						 int iSpeed );

int FAR PASCAL _export  sp_GetSample           ( int  iSessionHandler,
						 long lIndex );

int FAR PASCAL _export  sp_Copy2Clip           ( int  iSessionHandler,
						 long lStartByte,
						 long lEndByte);

int FAR PASCAL _export  sp_IsClipboard         ( void );

long FAR PASCAL _export sp_PlayClipboard       ( void );

int  FAR PASCAL _export sp_CreateNewWave       ( LPSTR sFileName, 
						 long  lSampRateSelected );

int FAR PASCAL _export  sp_CopyClip2Session    ( int  iSessionHandler,
						 long lFromByteLocation );

int  FAR PASCAL _export  sp_MouseON  ( int iSessionHandler );
int  FAR PASCAL _export  sp_MouseOFF ( int iSessionHandler );

int FAR PASCAL _export   ts_WaveDeviceCanPlay ( void );

}


/*----------
 #definition
 ----------*/

#define SP_OK                          1
#define SP_NO_MORE_SESSIONS_AVAILABLE -1
#define SP_CANNOT_OPEN_FILE           -2
#define SP_FILESIZE_ERROR             -3
#define SP_NOT_OK                     -4
#define SP_INVALID_SAMPLING_RATE      -5
#define SP_ALLOCATION_FAILURE         -6
#define SP_READ_ERROR                 -7
#define SP_INVALID_SESSION_HANDLER    -8
#define SP_NOT_ENOUGH_RAM             -9

#define SP_START_OF_FILE        -1L
#define SP_END_OF_FILE          -2L

#define SP_WAVE_OVERHEAD_BYTES 100
