// dancevw.cpp : implementation file
//

#include "stdafx.h"
#include "dance.h"
#include "dancevw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDanceView

IMPLEMENT_DYNCREATE(CDanceView, CFormView)

CDanceView::CDanceView()
	: CFormView(CDanceView::IDD)
{
	//{{AFX_DATA_INIT(CDanceView)
	m_midi = NULL;
	//}}AFX_DATA_INIT
}

CDanceView::~CDanceView()
{

  ///////////////////////
  // MY CODE STARTS HERE
  //////////////////////

  // Delete the 4 bitmaps.
  for (int i=0; i<4; i++)
      delete m_pB[i];

  ////////////////////
  // MY CODE ENDS HERE
  ////////////////////

}

void CDanceView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDanceView)
	DDX_VBControl(pDX, IDC_TEGOMM1, m_midi);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDanceView, CFormView)
	//{{AFX_MSG_MAP(CDanceView)
	ON_BN_CLICKED(IDC_START_BUTTON, OnStartButton)
	ON_VBXEVENT(VBN_STATUSUPDATE, IDC_TEGOMM1, OnStatusupdateTegomm1)
	ON_VBXEVENT(VBN_DONE, IDC_TEGOMM1, OnDoneTegomm1)
	ON_BN_CLICKED(IDC_STOP_BUTTON, OnStopButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDanceView message handlers


//////////////////////
// MY CODE STARTS HERE
//////////////////////

void CDanceView::OnInitialUpdate()
{

 // Call the base class function.
 CFormView::OnInitialUpdate();

 // Set the multimedia control for playback of MIDI files.
 m_midi->SetStrProperty("DeviceType","Sequencer");

 // Disable the timer of the multimedia control.
 m_midi->SetNumProperty("UpdateInterval",0);

 // Set the FileName property.
 m_midi->SetStrProperty("FileName",
                        "\\VCPROG\\MIDI\\BOURBON6.MID");

 // Make the multimedia control invisible.
 m_midi->SetNumProperty("Visible", FALSE);

 // Issue an Open command to the multimedia control.
 m_midi->SetStrProperty("Command","Open");

 // Load IDB_BITMAP1
 m_pB[0] = new CBitmap;
 m_pB[0]->LoadBitmap(IDB_BITMAP1);

 // Load IDB_BITMAP2
 m_pB[1] = new CBitmap;
 m_pB[1]->LoadBitmap(IDB_BITMAP2);

 // Load IDB_BITMAP3
 m_pB[2] = new CBitmap;
 m_pB[2]->LoadBitmap(IDB_BITMAP3);

 // Load IDB_BITMAP4
 m_pB[3] = new CBitmap;
 m_pB[3]->LoadBitmap(IDB_BITMAP4);

}

////////////////////
// MY CODE ENDS HERE
////////////////////

///////////////////////
// MY CODE STARTS HERE
///////////////////////

void CDanceView::OnDraw(CDC* pDC)
{

 // Create a memory DC.
 CDC* pMemDC = new CDC;
 pMemDC->CreateCompatibleDC(pDC);

 // Select the bitmap into the memory DC.
 pMemDC->SelectObject( m_pB[0] );

 // Copy the bitmap from the memory DC into the screen DC.
 pDC->BitBlt(100,10,500,500,pMemDC,0,0,SRCCOPY);

 // Delete the memory DC.
 delete pMemDC;

}

////////////////////
// MY CODE ENDS HERE
////////////////////

void CDanceView::OnStartButton()
{
	// TODO: Add your control notification handler code here
	
   //////////////////////
   // MY CODE STARTS HERE
   //////////////////////

   // Disable the Start push button.
   GetDlgItem(IDC_START_BUTTON)->EnableWindow(FALSE);

   // Initialize the current frame number to 0.
   m_CurrentFrame = 0;

   // Rewind the multimedia control.
   m_midi->SetStrProperty("Command","Prev");

   // Start playing the MIDI file.
   m_midi->SetStrProperty("Command","Play");

   // Set the interval of the multimedia control timer.
   m_midi->SetNumProperty("UpdateInterval",350);

   ////////////////////
   // MY CODE ENDS HERE
   ////////////////////

}

void CDanceView::OnStatusupdateTegomm1(UINT, int, CWnd*, LPVOID)
{
	// TODO: Add your VBX event notification handler code here

  //////////////////////
  // MY CODE STARTS HERE
  //////////////////////

  // Increment the current frame number.
  m_CurrentFrame++;

  // Was the last frame of the dance displayed?
  if (m_CurrentFrame==4)
     m_CurrentFrame=1;

  // Get a DC for the screen.
  CClientDC dc(this);

  // Create a memory DC.
  CDC* pMemDC = new CDC;
  pMemDC->CreateCompatibleDC(&dc);

  // Select the bitmap into the memory DC.
  pMemDC->SelectObject( m_pB[m_CurrentFrame] );

  // Copy the bitmap from the memory DC into the screen DC.
  dc.BitBlt(100,10,500,500,pMemDC,0,0,SRCCOPY);

  // Delete the memory DC.
  delete pMemDC;

  ////////////////////
  // MY CODE ENDS HERE
  ////////////////////
	
}

void CDanceView::OnDoneTegomm1(UINT, int, CWnd*, LPVOID)
{
	// TODO: Add your VBX event notification handler code here
	
   //////////////////////
   // MY CODE STARTS HERE
   //////////////////////

   // Disable the multimedia control timer.
   m_midi->SetNumProperty("UpdateInterval",0);

   // Enable the Start push button.
   GetDlgItem(IDC_START_BUTTON)->EnableWindow(TRUE);

   // Trigger a call to the OnDraw() function.
   Invalidate();

   ////////////////////
   // MY CODE ENDS HERE
   ////////////////////


}

void CDanceView::OnStopButton()
{
	// TODO: Add your control notification handler code here

   ///////////////////////
   // MY CODE STARTS HERE
   //////////////////////

   // Stop the playback.
   m_midi->SetStrProperty("Command","Stop");

   ////////////////////
   // MY CODE ENDS HERE
   ////////////////////

	
}
